import java.util.Arrays;

import junit.framework.Assert;
import junit.framework.TestCase;

/**
 * ITI 1220 Assignment 7, Question 2
 * JUnit test file
 * 
 * @author Alan Williams
 */
public class PermutationTest extends TestCase
{

	public static void main( String[] args )
	{
		junit.swingui.TestRunner.run( PermutationTest.class );
	}

	/*
	 * Test method for 'permutation.Permutations.permute(String)'
	 */
	public void testPermute1( )
	{
		String testData = "a";

		String[] expected = new String[] { "a" };
		String[] actual = Permutations.permute( testData );

		// Check that we got the correct number of permutations
		
		int lengthExpected = 1;
		int lengthActual = actual.length;
		Assert.assertEquals( lengthExpected, lengthActual );

		// Check the permutation
		
		Assert.assertEquals( expected[0], actual[0] );
	}

	/*
	 * Test method for 'permutation.Permutations.permute(String)'
	 */
	public void testPermute3( )
	{
		String testData = "abc";

		String[] expected = new String[] { "abc", "acb", "bac", "bca", "cab",
				"cba" };
		String[] actual = Permutations.permute( testData );
		
		// Sort the array of permutations, so that the order will be known in advance.
		
		Arrays.sort( actual );

		// Check that we got the correct number of permutations
		
		int lengthExpected = 6;
		int lengthActual = actual.length;
		Assert.assertEquals( lengthExpected, lengthActual );

		// Check each permutation
		
		for ( int index = 0; index < lengthActual; index++ )
		{
			Assert.assertEquals( expected[index], actual[index] );
		}
	}

	/*
	 * Test method for 'permutation.Permutations.permute(String)'
	 */
	public void testPermute5( )
	{
		String testData = "abcde";

		// 5! = 120:  There are 120 sorted permutations of "abcde" listed below
		
		String[] expected = new String[] { "abcde", "abced", "abdce", "abdec",
				"abecd", "abedc", "acbde", "acbed", "acdbe", "acdeb", "acebd",
				"acedb", "adbce", "adbec", "adcbe", "adceb", "adebc", "adecb",
				"aebcd", "aebdc", "aecbd", "aecdb", "aedbc", "aedcb", "bacde",
				"baced", "badce", "badec", "baecd", "baedc", "bcade", "bcaed",
				"bcdae", "bcdea", "bcead", "bceda", "bdace", "bdaec", "bdcae",
				"bdcea", "bdeac", "bdeca", "beacd", "beadc", "becad", "becda",
				"bedac", "bedca", "cabde", "cabed", "cadbe", "cadeb", "caebd",
				"caedb", "cbade", "cbaed", "cbdae", "cbdea", "cbead", "cbeda",
				"cdabe", "cdaeb", "cdbae", "cdbea", "cdeab", "cdeba", "ceabd",
				"ceadb", "cebad", "cebda", "cedab", "cedba", "dabce", "dabec",
				"dacbe", "daceb", "daebc", "daecb", "dbace", "dbaec", "dbcae",
				"dbcea", "dbeac", "dbeca", "dcabe", "dcaeb", "dcbae", "dcbea",
				"dceab", "dceba", "deabc", "deacb", "debac", "debca", "decab",
				"decba", "eabcd", "eabdc", "eacbd", "eacdb", "eadbc", "eadcb",
				"ebacd", "ebadc", "ebcad", "ebcda", "ebdac", "ebdca", "ecabd",
				"ecadb", "ecbad", "ecbda", "ecdab", "ecdba", "edabc", "edacb",
				"edbac", "edbca", "edcab", "edcba" };
		String[] actual = Permutations.permute( testData );

		// Sort the array of permutations, so that the order will be known in advance.
		
		Arrays.sort( actual );

		// Check that we got the correct number of permutations
		
		int lengthExpected = 120;
		int lengthActual = actual.length;
		Assert.assertEquals( lengthExpected, lengthActual );

		// Check each permutation
		
		for ( int index = 0; index < lengthActual; index++ )
		{
			Assert.assertEquals( expected[index], actual[index] );
		}

	}

}
